libzypp 17.36.7

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
zypp::media::MediaNetworkCommonHandler Class Reference

Baseclass for MediaCurl. More...

`#include <zypp/media/MediaNetworkCommonHandler.h>`

Inheritance diagram for zypp::media::MediaNetworkCommonHandler:

## Public Member Functions
| MediaNetworkCommonHandler (const Url &url_r, const Pathname &attach_point_r, const Pathname &urlpath_below_attachpoint_r, const bool does_download_r)
TransferSettings & | settings ()
Public Member Functions inherited from zypp::media::MediaHandler
bool | dependsOnParent (MediaAccessId parentId, bool exactIdMatch)
| Check if the current media handler depends on an another handler specified by media access id.
bool | dependsOnParent ()
void | resetParentId ()
| Called in case, where the media manager takes over the destruction of the parent id (e.g.
Pathname | attachPoint () const
| Return the currently used attach point.
void | setAttachPoint (const Pathname &path, bool temp)
| Set a new attach point.
void | setAttachPoint (const AttachPointRef &ref)
| Set a (shared) attach point.
AttachPoint | attachPointHint () const
| Get the actual attach point hint.
void | attachPointHint (const Pathname &path, bool temp)
| Set the attach point hint as specified by the user.
Pathname | createAttachPoint () const
| Try to create a default / temporary attach point.
Pathname | createAttachPoint (const Pathname &attach_root) const
| Try to create a temporary attach point in specified root.
void | removeAttachPoint ()
| Remove unused attach point.
virtual bool | checkAttachPoint (const Pathname &apoint) const
| Verify if the specified directory as attach point (root) as requires by the particular media handler implementation.
bool | isUseableAttachPoint (const Pathname &path, bool mtab=true) const
| Ask media manager, if the specified path is already used as attach point or if there are another attach points bellow of it.
std::string | mediaSourceName () const
| Get the media source name or an empty string.
void | setMediaSource (const MediaSourceRef &ref)
| Set new media source reference.
AttachedMedia | findAttachedMedia (const MediaSourceRef &media) const
| Ask the media manager if specified media source is already attached.
AttachedMedia | attachedMedia () const
| Returns the attached media.
bool | isSharedMedia () const
| Returns a hint if the media is shared or not.
bool | checkAttached (bool matchMountFs) const
| Check actual mediaSource attachment against the current mount table of the system.
void | forceRelaseAllMedia (bool matchMountFs)
| Call to this function will try to release all media matching the currenlty attached media source, that it is able to find in the mount table.
void | forceRelaseAllMedia (const MediaSourceRef &ref, bool matchMountFs)
| MediaHandler (Url url_r, const Pathname &attach_point_r, Pathname urlpath_below_attachpoint_r, const bool does_download_r)
| If the concrete media handler provides a nonempty attach_point, it must be an existing directory.
virtual | ~MediaHandler ()
| Contolling MediaAccess takes care, that attached media is released prior to deleting this.
bool | downloads () const
| Hint if files are downloaded or not.
std::string | protocol () const
| Protocol hint for MediaAccess.
Url | url () const
| Url used.
void | attach (bool next)
| Use concrete handler to attach the media.
virtual bool | isAttached () const
| True if media is attached.
Pathname | localRoot () const
| Return the local directory that corresponds to medias url, no matter if media isAttached or not.
Pathname | localPath (const Pathname &pathname) const
| Files provided will be available at 'localPath(filename)'.
void | disconnect ()
| Use concrete handler to isconnect media.
void | release (const std::string &ejectDev="")
| Use concrete handler to release the media.
void | provideFile (const OnMediaLocation &file) const
| Use concrete handler to provide file denoted by path below 'localRoot'.
void | provideFileCopy (const OnMediaLocation &srcFile, const Pathname &targetFilename) const
| Call concrete handler to provide a copy of a file under a different place in the file system (usually not under attach point) as a copy.
void | provideDir (const Pathname &dirname) const
| Use concrete handler to provide directory denoted by path below 'localRoot' (not recursive!).
void | provideDirTree (const Pathname &dirname) const
| Use concrete handler to provide directory tree denoted by path below 'localRoot' (recursive!
void | releaseFile (const Pathname &filename) const
| Remove filename below localRoot IFF handler downloads files to the local filesystem.
void | releaseDir (const Pathname &dirname) const
| Remove directory tree below localRoot IFF handler downloads files to the local filesystem.
void | releasePath (const Pathname &pathname) const
| Remove pathname below localRoot IFF handler downloads files to the local filesystem.
void | dirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Return content of directory on media via retlist.
void | dirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Basically the same as dirInfo above.
bool | doesFileExist (const Pathname &filename) const
| check if a file exists
virtual bool | hasMoreDevices ()
| Check if the media has one more device available for attach(true).
virtual void | getDetectedDevices (std::vector< std::string > &devices, unsigned int &index) const
| Fill in a vector of detected ejectable devices and the index of the currently attached device within the vector.
virtual void | precacheFiles (const std::vector< OnMediaLocation > &files)
| Tries to fetch the given files and precaches them.

## Static Public Member Functions
static const char * | anonymousIdHeader ()
static const char * | distributionFlavorHeader ()
static const char * | agentString ()
Static Public Member Functions inherited from zypp::media::MediaHandler
static bool | setAttachPrefix (const Pathname &attach_prefix)
static std::string | getRealPath (const std::string &path)
static Pathname | getRealPath (const Pathname &path)
static bool | checkAttachPoint (const Pathname &apoint, bool empty_dir, bool writeable)
| Verify if the specified directory as attach point (root) using requested checks.

## Protected Member Functions
Url | getFileUrl (const Pathname &filename) const
| concatenate the attach url and the filename to a complete download url
Protected Member Functions inherited from zypp::media::MediaHandler
virtual void | attachTo (bool next=false)=0
| Call concrete handler to attach the media.
virtual void | disconnectFrom ()
| Call concrete handler to disconnect media.
virtual void | releaseFrom (const std::string &ejectDev="")=0
| Call concrete handler to release the media.
virtual void | forceEject (const std::string &device)
| Call concrete handler to physically eject the media (i.e.
virtual void | getFile (const OnMediaLocation &file) const
| Call concrete handler to provide file below attach point.
virtual void | getFileCopy (const OnMediaLocation &file, const Pathname &targetFilename) const
| Call concrete handler to provide a file under a different place in the file system (usually not under attach point) as a copy.
virtual void | getDir (const Pathname &dirname, bool recurse_r) const =0
| Call concrete handler to provide directory content (not recursive!) below attach point.
virtual void | getDirInfo (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const =0
| Call concrete handler to provide a content list of directory on media via retlist.
virtual void | getDirInfo (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const =0
| Basically the same as getDirInfo above.
virtual bool | getDoesFileExist (const Pathname &filename) const =0
| check if a file exists
void | getDirectoryYast (std::list< std::string > &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast.
void | getDirectoryYast (filesystem::DirContent &retlist, const Pathname &dirname, bool dots=true) const
| Retrieve and if available scan dirname/directory.yast.

## Static Protected Member Functions
static zypp::Url | findGeoIPRedirect (const zypp::Url &url)
| Rewrites the baseURL to the geoIP target if one is found in the metadata cache, otherwise simply returns the url again.

## Protected Attributes
TransferSettings | _settings
Url | _redirTarget
Protected Attributes inherited from zypp::media::MediaHandler
const Url | _url
| Url to handle.
MediaAccessId | _parentId
| Access Id of media handler we depend on.

## Additional Inherited Members
Public Types inherited from zypp::media::MediaHandler
using | Ptr = shared_ptr<MediaHandler>
using | constPtr = shared_ptr<const MediaHandler>

## Detailed Description

Baseclass for MediaCurl.

Access to commonly used stuff like TransferSettings mainly

Definition at line 30 of file MediaNetworkCommonHandler.h.

## Constructor & Destructor Documentation

## ◆ MediaNetworkCommonHandler()

zypp::media::MediaNetworkCommonHandler::MediaNetworkCommonHandler | ( | const Url & | url_r,
|  | const Pathname & | attach_point_r,
|  | const Pathname & | urlpath_below_attachpoint_r,
|  | const bool | does_download_r )
| inline

Definition at line 33 of file MediaNetworkCommonHandler.h.

## Member Function Documentation

## ◆ settings()

TransferSettings & zypp::media::MediaNetworkCommonHandler::settings | ( |  | ) |
| inline

Definition at line 43 of file MediaNetworkCommonHandler.h.

## ◆ getFileUrl()

Url zypp::media::MediaNetworkCommonHandler::getFileUrl | ( | const Pathname & | filename | ) | const
| protected

concatenate the attach url and the filename to a complete download url

Definition at line 105 of file MediaNetworkCommonHandler.cc.

## ◆ findGeoIPRedirect()

zypp::Url zypp::media::MediaNetworkCommonHandler::findGeoIPRedirect | ( | const zypp::Url & | url | ) |
| static protected

Rewrites the baseURL to the geoIP target if one is found in the metadata cache, otherwise simply returns the url again.

Definition at line 26 of file MediaNetworkCommonHandler.cc.

## ◆ anonymousIdHeader()

const char * zypp::media::MediaNetworkCommonHandler::anonymousIdHeader | ( |  | ) |
| static

Definition at line 77 of file MediaNetworkCommonHandler.cc.

## ◆ distributionFlavorHeader()

const char * zypp::media::MediaNetworkCommonHandler::distributionFlavorHeader | ( |  | ) |
| static

Definition at line 91 of file MediaNetworkCommonHandler.cc.

## ◆ agentString()

const char * zypp::media::MediaNetworkCommonHandler::agentString | ( |  | ) |
| static

Definition at line 121 of file MediaNetworkCommonHandler.cc.

## Member Data Documentation

## ◆ _settings

TransferSettings zypp::media::MediaNetworkCommonHandler::_settings
| mutable protected

Definition at line 69 of file MediaNetworkCommonHandler.h.

## ◆ _redirTarget

Url zypp::media::MediaNetworkCommonHandler::_redirTarget
| protected

Definition at line 70 of file MediaNetworkCommonHandler.h.

The documentation for this class was generated from the following files:

- zypp/media/MediaNetworkCommonHandler.h
- zypp/media/MediaNetworkCommonHandler.cc